
// OPERATOR: +(LX,LX) ______________________________________

 template<typename ALX, typename BLX>
 friend
 mtx<typename decay<decltype(declval<ALX>()+
                             declval<BLX>() )
                   >::type
    >
 operator+(mtx<ALX> const& a, mtx<BLX> const& b)            ;

// OPERATOR: +(LX,RT) ______________________________________

 template<typename ALX, typename BRT>
 friend
 typename enable_if
         <!is_same<typename decay<decltype(declval<ALX>()+
                                           declval<BRT>() )
                                 >::type,
                   typename decay<decltype(declval<BRT>() )
                                 >::type
                  >::value,
           mtx<typename     decay<decltype(declval<ALX>()+
                                           declval<BRT>() )
                                 >::type
              >
          >::type
 operator+(mtx<ALX> const& a, mtx<BRT> && b)                ;

// OPERATOR: +(LX,RW) ______________________________________

 template<typename ALX, typename BRW>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ALX>()+
                                           declval<BRW>() )
                                 >::type,
                   typename decay<decltype(declval<BRW>() )
                                 >::type
                  >::value,
           mtx<typename     decay<decltype(declval<ALX>()+
                                           declval<BRW>() )
                                 >::type
              >
          >::type&&
 operator+(mtx<ALX> const& a, mtx<BRW> && b)                ;

// OPERATOR: +(RT,LX) ______________________________________

 template<typename ART, typename BLX>
 friend
 typename enable_if
         <!is_same<typename decay<decltype(declval<ART>()+
                                           declval<BLX>() )
                                 >::type,
                   typename decay<decltype(declval<ART>() )
                                 >::type
                  >::value,
           mtx<typename     decay<decltype(declval<ART>()+
                                           declval<BLX>() )
                                 >::type
              >
          >::type
 operator+(mtx<ART> && a, mtx<BLX> const& b)                ;

// OPERATOR: +(RW,LX) ______________________________________

 template<typename ARW, typename BLX>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ARW>()+
                                           declval<BLX>() )
                                 >::type,
                   typename decay<decltype(declval<ARW>() )
                                 >::type
                  >::value,
           mtx<typename     decay<decltype(declval<ARW>()+
                                           declval<BLX>() )
                                 >::type
              >
          >::type&&
 operator+(mtx<ARW> && a, mtx<BLX> const& b)                ;

// OPERATOR: +(RW,RX) ______________________________________

 template<typename ARW, typename BRX>
 friend
 typename enable_if
          <is_same<typename decay<decltype(declval<ARW>()+
                                           declval<BRX>() )
                                 >::type,
                   typename decay<decltype(declval<ARW>() )
                                 >::type
                  >::value,
           mtx<typename     decay<decltype(declval<ARW>()+
                                           declval<BRX>() )
                                 >::type
              >
          >::type&&
 operator+(mtx<ARW> && a, mtx<BRX> && b)                    ;

// OPERATOR: +(RT,RW) ______________________________________

 template<typename ART, typename BRW>
 friend
 typename enable_if
        <!is_same<typename decay<decltype(declval<ART>() )
                                >::type,
                  typename decay<decltype(declval<ART>()+
                                          declval<BRW>() )
                                >::type
                 >::value
                 &&
          is_same<typename decay<decltype(declval<BRW>() )
                                >::type,
                  typename decay<decltype(declval<ART>()+
                                          declval<BRW>() )
                                >::type
                 >::value,
           mtx<typename     decay<decltype(declval<ART>()+
                                           declval<BRW>() )
                                 >::type
              >
          >::type&&
 operator+(mtx<ART> && a, mtx<BRW> && b)                    ;

// OPERATOR: +(RT,RT) ______________________________________

 template<typename ART, typename BRT>
 friend
 typename enable_if
        <!is_same<typename decay<decltype(declval<ART>() )
                                >::type,
                  typename decay<decltype(declval<ART>()+
                                          declval<BRT>() )
                                >::type
                 >::value
                 &&
         !is_same<typename decay<decltype(declval<BRT>() )
                                >::type,
                  typename decay<decltype(declval<ART>()+
                                          declval<BRT>() )
                                >::type
                 >::value,
           mtx<typename     decay<decltype(declval<ART>()+
                                           declval<BRT>() )
                                 >::type
              >
          >::type
 operator+(mtx<ART> && a, mtx<BRT> && b)                    ;

// OPERATOR: +(alx,BLX) ____________________________________

 template<typename alx, typename BLX>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<alx>())
                                     >::type
                      >::value,
   mtx<typename decay<decltype(declval<alx>()+
                               declval<BLX>())>::type>
            >::type
   operator+(alx const& a, mtx<BLX> const& b)               ;

// OPERATOR: +(alx,BRT) ____________________________________

 template<typename alx, typename BRT>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<alx>()+
                                              declval<BRT>() )
                                    >::type,
                      BRT>::value
              &&
              is_cscalar<typename decay<decltype(declval<alx>())
                                      >::type
                       >::value,
   mtx<typename decay<decltype(declval<alx>()+
                               declval<BRT>())>::type>
            >::type
   operator+(alx const& a, mtx<BRT>&& b)                    ;

// OPERATOR: +(alx,BRW) ____________________________________

 template<typename alx, typename BRW>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<alx>()+
                                             declval<BRW>() )
                                   >::type,
                     BRW>::value
             &&
             is_cscalar<typename decay<decltype(declval<alx>())
                                     >::type
                      >::value,
             mtx<BRW>
            >::type&&
   operator+(alx const& a, mtx<BRW>&& b)                    ;

// OPERATOR: +(ALX,blx) ____________________________________

 template<typename ALX, typename blx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
   mtx<typename decay<decltype(declval<ALX>()+
                               declval<blx>())>::type>
            >::type
   operator+(mtx<ALX> const& a, blx const& b)               ;

// OPERATOR: +(ART,blx) ____________________________________

 template<typename ART, typename blx>
 friend
   typename
   enable_if<!is_same<typename decay<decltype(declval<ART>()+
                                              declval<blx>() )
                                    >::type,
                      ART>::value
              &&
              is_cscalar<typename decay<decltype(declval<blx>())
                                      >::type
                       >::value,
   mtx<typename decay<decltype(declval<ART>()+
                               declval<blx>())>::type>
            >::type
   operator+(mtx<ART> && a, blx const& b)                   ;

// OPERATOR: +(ARW,blx) ____________________________________

 template<typename ARW, typename blx>
 friend
   typename
   enable_if<is_same<typename decay<decltype(declval<ARW>()+
                                             declval<blx>() )
                                   >::type,
                     ARW>::value
             &&
             is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
             mtx<ARW>
            >::type&&
   operator+(mtx<ARW> && a, blx const& b)                   ;

// OPERATOR: +=

 template<typename ALX, typename BLX>
 friend
   mtx<BLX>&
   operator+=(mtx<ALX>& a, mtx<BLX>& b)                     ;

 template<typename ALX, typename BRX>
 friend
   mtx<BRX>&&
   operator+=(mtx<ALX>& a, mtx<BRX> && b)                   ;

 template<typename ALX, typename blx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<blx>())
                                     >::type
                      >::value,
             blx>::type&
   operator+=(mtx<ALX>& a, blx& b)                          ;

 template<typename ALX, typename brx>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<brx>())
                                     >::type
                      >::value,
             brx>::type&&
   operator+=(mtx<ALX>& a, brx && b)                        ;

 template<typename alx, typename BLX>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<alx>())
                                     >::type
                      >::value,
             mtx<BLX>>::type&
   operator+=(alx& a, mtx<BLX>& b)                          ;

 template<typename alx, typename BRX>
 friend
   typename
   enable_if<is_cscalar<typename decay<decltype(declval<alx>())
                                     >::type
                      >::value,
             mtx<BRX>>::type&&
   operator+=(alx& a, mtx<BRX>&& b)                         ;

